/* Error.c : Dialog boxes for emulator errors.
 *
 * Copyright 1996 Rui Fernando Ferreira Ribeiro.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <windows.h>
#include <commdlg.h>
#include <string.h>
#include <ctype.h>
#include "env.h"

/*=========================================================================*
 *                            warning                                      *
 *                                                                         *
 * Non fatal error, just gives the message                                 * 								
 *=========================================================================*/
void Warning(msg)
const char * msg;
{
   MessageBox(NULL, msg, "WARNING", MB_OK | MB_ICONSTOP);
}

/*=========================================================================*
 *                            panic                                        *
 *                                                                         *
 * Critical error, reset the emulation                                     *
 *=========================================================================*/
void Panic(msg)
const char * msg;
{
   Warning(msg);
   do_reset();
}

/* EOF: Error.c */
