/* Bits.c : Z80 bit manipulation instructions.
 *
 * Copyright 1996 Rui Fernando Ferreira Ribeiro.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "env.h"

/*=========================================================================*
 *                            bit_b_r                                      *
 *=========================================================================*/

#define bit_b_r(R, BIT,TS)  {\
   T(TS); \
   flags._Z = flags._P = !((R) & (UCHAR)(BIT)); \
   flags._H = 1; \
   flags._N = 0; \
   flags._S = (R) & (UCHAR)BIT_7; \
   flags._X = (R) & (UCHAR)BIT_5; \
   flags._Y = (R) & (UCHAR)BIT_3; \
}

void bit_7_b() bit_b_r(B, BIT_7, 8);
void bit_6_b() bit_b_r(B, BIT_6, 8);
void bit_5_b() bit_b_r(B, BIT_5, 8);
void bit_4_b() bit_b_r(B, BIT_4, 8);
void bit_3_b() bit_b_r(B, BIT_3, 8);
void bit_2_b() bit_b_r(B, BIT_2, 8);
void bit_1_b() bit_b_r(B, BIT_1, 8);
void bit_0_b() bit_b_r(B, BIT_0, 8);
void bit_7_c() bit_b_r(C, BIT_7, 8);
void bit_6_c() bit_b_r(C, BIT_6, 8);
void bit_5_c() bit_b_r(C, BIT_5, 8);
void bit_4_c() bit_b_r(C, BIT_4, 8);
void bit_3_c() bit_b_r(C, BIT_3, 8);
void bit_2_c() bit_b_r(C, BIT_2, 8);
void bit_1_c() bit_b_r(C, BIT_1, 8);
void bit_0_c() bit_b_r(C, BIT_0, 8);
void bit_7_d() bit_b_r(D, BIT_7, 8);
void bit_6_d() bit_b_r(D, BIT_6, 8);
void bit_5_d() bit_b_r(D, BIT_5, 8);
void bit_4_d() bit_b_r(D, BIT_4, 8);
void bit_3_d() bit_b_r(D, BIT_3, 8);
void bit_2_d() bit_b_r(D, BIT_2, 8);
void bit_1_d() bit_b_r(D, BIT_1, 8);
void bit_0_d() bit_b_r(D, BIT_0, 8);
void bit_7_e() bit_b_r(E, BIT_7, 8);
void bit_6_e() bit_b_r(E, BIT_6, 8);
void bit_5_e() bit_b_r(E, BIT_5, 8);
void bit_4_e() bit_b_r(E, BIT_4, 8);
void bit_3_e() bit_b_r(E, BIT_3, 8);
void bit_2_e() bit_b_r(E, BIT_2, 8);
void bit_1_e() bit_b_r(E, BIT_1, 8);
void bit_0_e() bit_b_r(E, BIT_0, 8);
void bit_7_h() bit_b_r(H, BIT_7, 8);
void bit_6_h() bit_b_r(H, BIT_6, 8);
void bit_5_h() bit_b_r(H, BIT_5, 8);
void bit_4_h() bit_b_r(H, BIT_4, 8);
void bit_3_h() bit_b_r(H, BIT_3, 8);
void bit_2_h() bit_b_r(H, BIT_2, 8);
void bit_1_h() bit_b_r(H, BIT_1, 8);
void bit_0_h() bit_b_r(H, BIT_0, 8);
void bit_7_Ix() bit_b_r(HX, BIT_7, 15);
void bit_6_Ix() bit_b_r(HX, BIT_6, 15);
void bit_5_Ix() bit_b_r(HX, BIT_5, 15);
void bit_4_Ix() bit_b_r(HX, BIT_4, 15);
void bit_3_Ix() bit_b_r(HX, BIT_3, 15);
void bit_2_Ix() bit_b_r(HX, BIT_2, 15);
void bit_1_Ix() bit_b_r(HX, BIT_1, 15);
void bit_0_Ix() bit_b_r(HX, BIT_0, 15);
void bit_7_Iy() bit_b_r(HY, BIT_7, 15);
void bit_6_Iy() bit_b_r(HY, BIT_6, 15);
void bit_5_Iy() bit_b_r(HY, BIT_5, 15);
void bit_4_Iy() bit_b_r(HY, BIT_4, 15);
void bit_3_Iy() bit_b_r(HY, BIT_3, 15);
void bit_2_Iy() bit_b_r(HY, BIT_2, 15);
void bit_1_Iy() bit_b_r(HY, BIT_1, 15);
void bit_0_Iy() bit_b_r(HY, BIT_0, 15);
void bit_7_l() bit_b_r(L, BIT_7, 8);
void bit_6_l() bit_b_r(L, BIT_6, 8);
void bit_5_l() bit_b_r(L, BIT_5, 8);
void bit_4_l() bit_b_r(L, BIT_4, 8);
void bit_3_l() bit_b_r(L, BIT_3, 8);
void bit_2_l() bit_b_r(L, BIT_2, 8);
void bit_1_l() bit_b_r(L, BIT_1, 8);
void bit_0_l() bit_b_r(L, BIT_0, 8);
void bit_7_iX() bit_b_r(LX, BIT_7, 15);
void bit_6_iX() bit_b_r(LX, BIT_6, 15);
void bit_5_iX() bit_b_r(LX, BIT_5, 15);
void bit_4_iX() bit_b_r(LX, BIT_4, 15);
void bit_3_iX() bit_b_r(LX, BIT_3, 15);
void bit_2_iX() bit_b_r(LX, BIT_2, 15);
void bit_1_iX() bit_b_r(LX, BIT_1, 15);
void bit_0_iX() bit_b_r(LX, BIT_0, 15);
void bit_7_iY() bit_b_r(LY, BIT_7, 15);
void bit_6_iY() bit_b_r(LY, BIT_6, 15);
void bit_5_iY() bit_b_r(LY, BIT_5, 15);
void bit_4_iY() bit_b_r(LY, BIT_4, 15);
void bit_3_iY() bit_b_r(LY, BIT_3, 15);
void bit_2_iY() bit_b_r(LY, BIT_2, 15);
void bit_1_iY() bit_b_r(LY, BIT_1, 15);
void bit_0_iY() bit_b_r(LY, BIT_0, 15);
void bit_7_a() bit_b_r(A, BIT_7, 8);
void bit_6_a() bit_b_r(A, BIT_6, 8);
void bit_5_a() bit_b_r(A, BIT_5, 8);
void bit_4_a() bit_b_r(A, BIT_4, 8);
void bit_3_a() bit_b_r(A, BIT_3, 8);
void bit_2_a() bit_b_r(A, BIT_2, 8);
void bit_1_a() bit_b_r(A, BIT_1, 8);
void bit_0_a() bit_b_r(A, BIT_0, 8);

#undef bit_b_r

/*=========================================================================*
 *                            bit_b_phl                                    *
 *=========================================================================*/

#define bit_b_phl(BIT,expr,TS) { \
	LOCAL UCHAR tmp; \
	\
	T(TS); \
	flags._Z = flags._P = !((tmp = readbyte(expr)) \
							  & (UCHAR)(BIT)); \
	flags._H = 1; \
	flags._N = 0; \
	flags._S = tmp & (UCHAR)BIT_7; \
	flags._X = tmp & (UCHAR)BIT_5; \
	flags._Y = tmp & (UCHAR)BIT_3; \
}


void bit_7_phl() bit_b_phl(BIT_7, HL, 12);
void bit_6_phl() bit_b_phl(BIT_6, HL, 12);
void bit_5_phl() bit_b_phl(BIT_5, HL, 12);
void bit_4_phl() bit_b_phl(BIT_4, HL, 12);
void bit_3_phl() bit_b_phl(BIT_3, HL, 12);
void bit_2_phl() bit_b_phl(BIT_2, HL, 12);
void bit_1_phl() bit_b_phl(BIT_1, HL, 12);
void bit_0_phl() bit_b_phl(BIT_0, HL, 12);
void bit_7_pix() bit_b_phl(BIT_7, pCBIX, 20);
void bit_6_pix() bit_b_phl(BIT_6, pCBIX, 20);
void bit_5_pix() bit_b_phl(BIT_5, pCBIX, 20);
void bit_4_pix() bit_b_phl(BIT_4, pCBIX, 20);
void bit_3_pix() bit_b_phl(BIT_3, pCBIX, 20);
void bit_2_pix() bit_b_phl(BIT_2, pCBIX, 20);
void bit_1_pix() bit_b_phl(BIT_1, pCBIX, 20);
void bit_0_pix() bit_b_phl(BIT_0, pCBIX, 20);
void bit_7_piy() bit_b_phl(BIT_7, pCBIY, 20);
void bit_6_piy() bit_b_phl(BIT_6, pCBIY, 20);
void bit_5_piy() bit_b_phl(BIT_5, pCBIY, 20);
void bit_4_piy() bit_b_phl(BIT_4, pCBIY, 20);
void bit_3_piy() bit_b_phl(BIT_3, pCBIY, 20);
void bit_2_piy() bit_b_phl(BIT_2, pCBIY, 20);
void bit_1_piy() bit_b_phl(BIT_1, pCBIY, 20);
void bit_0_piy() bit_b_phl(BIT_0, pCBIY, 20);
#undef bit_b_phl

/*=========================================================================*
 *                            set_b_r                                      *
 *=========================================================================*/

#define set_b_r(R, BIT,TS) { \
	T(TS); \
	(R) |= (UCHAR)(BIT); \
	}

void set_7_b() set_b_r(B, BIT_7, 8);
void set_6_b() set_b_r(B, BIT_6, 8);
void set_5_b() set_b_r(B, BIT_5, 8);
void set_4_b() set_b_r(B, BIT_4, 8);
void set_3_b() set_b_r(B, BIT_3, 8);
void set_2_b() set_b_r(B, BIT_2, 8);
void set_1_b() set_b_r(B, BIT_1, 8);
void set_0_b() set_b_r(B, BIT_0, 8);
void set_7_c() set_b_r(C, BIT_7, 8);
void set_6_c() set_b_r(C, BIT_6, 8);
void set_5_c() set_b_r(C, BIT_5, 8);
void set_4_c() set_b_r(C, BIT_4, 8);
void set_3_c() set_b_r(C, BIT_3, 8);
void set_2_c() set_b_r(C, BIT_2, 8);
void set_1_c() set_b_r(C, BIT_1, 8);
void set_0_c() set_b_r(C, BIT_0, 8);
void set_7_d() set_b_r(D, BIT_7, 8);
void set_6_d() set_b_r(D, BIT_6, 8);
void set_5_d() set_b_r(D, BIT_5, 8);
void set_4_d() set_b_r(D, BIT_4, 8);
void set_3_d() set_b_r(D, BIT_3, 8);
void set_2_d() set_b_r(D, BIT_2, 8);
void set_1_d() set_b_r(D, BIT_1, 8);
void set_0_d() set_b_r(D, BIT_0, 8);
void set_7_e() set_b_r(E, BIT_7, 8);
void set_6_e() set_b_r(E, BIT_6, 8);
void set_5_e() set_b_r(E, BIT_5, 8);
void set_4_e() set_b_r(E, BIT_4, 8);
void set_3_e() set_b_r(E, BIT_3, 8);
void set_2_e() set_b_r(E, BIT_2, 8);
void set_1_e() set_b_r(E, BIT_1, 8);
void set_0_e() set_b_r(E, BIT_0, 8);
void set_7_h() set_b_r(H, BIT_7, 8);
void set_6_h() set_b_r(H, BIT_6, 8);
void set_5_h() set_b_r(H, BIT_5, 8);
void set_4_h() set_b_r(H, BIT_4, 8);
void set_3_h() set_b_r(H, BIT_3, 8);
void set_2_h() set_b_r(H, BIT_2, 8);
void set_1_h() set_b_r(H, BIT_1, 8);
void set_0_h() set_b_r(H, BIT_0, 8);
void set_7_Ix() set_b_r(HX, BIT_7, 15);
void set_6_Ix() set_b_r(HX, BIT_6, 15);
void set_5_Ix() set_b_r(HX, BIT_5, 15);
void set_4_Ix() set_b_r(HX, BIT_4, 15);
void set_3_Ix() set_b_r(HX, BIT_3, 15);
void set_2_Ix() set_b_r(HX, BIT_2, 15);
void set_1_Ix() set_b_r(HX, BIT_1, 15);
void set_0_Ix() set_b_r(HX, BIT_0, 15);
void set_7_Iy() set_b_r(HY, BIT_7, 15);
void set_6_Iy() set_b_r(HY, BIT_6, 15);
void set_5_Iy() set_b_r(HY, BIT_5, 15);
void set_4_Iy() set_b_r(HY, BIT_4, 15);
void set_3_Iy() set_b_r(HY, BIT_3, 15);
void set_2_Iy() set_b_r(HY, BIT_2, 15);
void set_1_Iy() set_b_r(HY, BIT_1, 15);
void set_0_Iy() set_b_r(HY, BIT_0, 15);
void set_7_l() set_b_r(L, BIT_7, 8);
void set_6_l() set_b_r(L, BIT_6, 8);
void set_5_l() set_b_r(L, BIT_5, 8);
void set_4_l() set_b_r(L, BIT_4, 8);
void set_3_l() set_b_r(L, BIT_3, 8);
void set_2_l() set_b_r(L, BIT_2, 8);
void set_1_l() set_b_r(L, BIT_1, 8);
void set_0_l() set_b_r(L, BIT_0, 8);
void set_7_iX() set_b_r(LX, BIT_7, 15);
void set_6_iX() set_b_r(LX, BIT_6, 15);
void set_5_iX() set_b_r(LX, BIT_5, 15);
void set_4_iX() set_b_r(LX, BIT_4, 15);
void set_3_iX() set_b_r(LX, BIT_3, 15);
void set_2_iX() set_b_r(LX, BIT_2, 15);
void set_1_iX() set_b_r(LX, BIT_1, 15);
void set_0_iX() set_b_r(LX, BIT_0, 15);
void set_7_iY() set_b_r(LY, BIT_7, 15);
void set_6_iY() set_b_r(LY, BIT_6, 15);
void set_5_iY() set_b_r(LY, BIT_5, 15);
void set_4_iY() set_b_r(LY, BIT_4, 15);
void set_3_iY() set_b_r(LY, BIT_3, 15);
void set_2_iY() set_b_r(LY, BIT_2, 15);
void set_1_iY() set_b_r(LY, BIT_1, 15);
void set_0_iY() set_b_r(LY, BIT_0, 15);
void set_7_a() set_b_r(A, BIT_7, 8);
void set_6_a() set_b_r(A, BIT_6, 8);
void set_5_a() set_b_r(A, BIT_5, 8);
void set_4_a() set_b_r(A, BIT_4, 8);
void set_3_a() set_b_r(A, BIT_3, 8);
void set_2_a() set_b_r(A, BIT_2, 8);
void set_1_a() set_b_r(A, BIT_1, 8);
void set_0_a() set_b_r(A, BIT_0, 8);

#undef set_b_r

/*=========================================================================*
 *                            set_b_phl                                    *
 *=========================================================================*/

#define set_b_phl(BIT,expr,TS) { \
	LOCAL USHORT tmp; \
	\
	T(TS); \
	tmp = expr; \
	writebyte(tmp, readbyte(tmp) | (UCHAR)(BIT) ); \
}

void set_7_phl() set_b_phl(BIT_7,HL,15);
void set_6_phl() set_b_phl(BIT_6,HL,15);
void set_5_phl() set_b_phl(BIT_5,HL,15);
void set_4_phl() set_b_phl(BIT_4,HL,15);
void set_3_phl() set_b_phl(BIT_3,HL,15);
void set_2_phl() set_b_phl(BIT_2,HL,15);
void set_1_phl() set_b_phl(BIT_1,HL,15);
void set_0_phl() set_b_phl(BIT_0,HL,15);
void set_7_pix() set_b_phl(BIT_7, pCBIX, 23);
void set_6_pix() set_b_phl(BIT_6, pCBIX, 23);
void set_5_pix() set_b_phl(BIT_5, pCBIX, 23);
void set_4_pix() set_b_phl(BIT_4, pCBIX, 23);
void set_3_pix() set_b_phl(BIT_3, pCBIX, 23);
void set_2_pix() set_b_phl(BIT_2, pCBIX, 23);
void set_1_pix() set_b_phl(BIT_1, pCBIX, 23);
void set_0_pix() set_b_phl(BIT_0, pCBIX, 23);
void set_7_piy() set_b_phl(BIT_7, pCBIY, 23);
void set_6_piy() set_b_phl(BIT_6, pCBIY, 23);
void set_5_piy() set_b_phl(BIT_5, pCBIY, 23);
void set_4_piy() set_b_phl(BIT_4, pCBIY, 23);
void set_3_piy() set_b_phl(BIT_3, pCBIY, 23);
void set_2_piy() set_b_phl(BIT_2, pCBIY, 23);
void set_1_piy() set_b_phl(BIT_1, pCBIY, 23);
void set_0_piy() set_b_phl(BIT_0, pCBIY, 23);

#undef set_b_phl

/*=========================================================================*
 *                            res_b_r                                      *
 *=========================================================================*/

#define res_b_r(R, BIT, TS) { \
	T(TS); \
	(R) &= ~(UCHAR)(BIT); \
}

void res_7_b() res_b_r(B, BIT_7, 8);
void res_6_b() res_b_r(B, BIT_6, 8);
void res_5_b() res_b_r(B, BIT_5, 8);
void res_4_b() res_b_r(B, BIT_4, 8);
void res_3_b() res_b_r(B, BIT_3, 8);
void res_2_b() res_b_r(B, BIT_2, 8);
void res_1_b() res_b_r(B, BIT_1, 8);
void res_0_b() res_b_r(B, BIT_0, 8);
void res_7_c() res_b_r(C, BIT_7, 8);
void res_6_c() res_b_r(C, BIT_6, 8);
void res_5_c() res_b_r(C, BIT_5, 8);
void res_4_c() res_b_r(C, BIT_4, 8);
void res_3_c() res_b_r(C, BIT_3, 8);
void res_2_c() res_b_r(C, BIT_2, 8);
void res_1_c() res_b_r(C, BIT_1, 8);
void res_0_c() res_b_r(C, BIT_0, 8);
void res_7_d() res_b_r(D, BIT_7, 8);
void res_6_d() res_b_r(D, BIT_6, 8);
void res_5_d() res_b_r(D, BIT_5, 8);
void res_4_d() res_b_r(D, BIT_4, 8);
void res_3_d() res_b_r(D, BIT_3, 8);
void res_2_d() res_b_r(D, BIT_2, 8);
void res_1_d() res_b_r(D, BIT_1, 8);
void res_0_d() res_b_r(D, BIT_0, 8);
void res_7_e() res_b_r(E, BIT_7, 8);
void res_6_e() res_b_r(E, BIT_6, 8);
void res_5_e() res_b_r(E, BIT_5, 8);
void res_4_e() res_b_r(E, BIT_4, 8);
void res_3_e() res_b_r(E, BIT_3, 8);
void res_2_e() res_b_r(E, BIT_2, 8);
void res_1_e() res_b_r(E, BIT_1, 8);
void res_0_e() res_b_r(E, BIT_0, 8);
void res_7_h() res_b_r(H, BIT_7, 8);
void res_6_h() res_b_r(H, BIT_6, 8);
void res_5_h() res_b_r(H, BIT_5, 8);
void res_4_h() res_b_r(H, BIT_4, 8);
void res_3_h() res_b_r(H, BIT_3, 8);
void res_2_h() res_b_r(H, BIT_2, 8);
void res_1_h() res_b_r(H, BIT_1, 8);
void res_0_h() res_b_r(H, BIT_0, 8);
void res_7_Ix() res_b_r(HX, BIT_7, 15);
void res_6_Ix() res_b_r(HX, BIT_6, 15);
void res_5_Ix() res_b_r(HX, BIT_5, 15);
void res_4_Ix() res_b_r(HX, BIT_4, 15);
void res_3_Ix() res_b_r(HX, BIT_3, 15);
void res_2_Ix() res_b_r(HX, BIT_2, 15);
void res_1_Ix() res_b_r(HX, BIT_1, 15);
void res_0_Ix() res_b_r(HX, BIT_0, 15);
void res_7_Iy() res_b_r(HY, BIT_7, 15);
void res_6_Iy() res_b_r(HY, BIT_6, 15);
void res_5_Iy() res_b_r(HY, BIT_5, 15);
void res_4_Iy() res_b_r(HY, BIT_4, 15);
void res_3_Iy() res_b_r(HY, BIT_3, 15);
void res_2_Iy() res_b_r(HY, BIT_2, 15);
void res_1_Iy() res_b_r(HY, BIT_1, 15);
void res_0_Iy() res_b_r(HY, BIT_0, 15);
void res_7_l() res_b_r(L, BIT_7, 8);
void res_6_l() res_b_r(L, BIT_6, 8);
void res_5_l() res_b_r(L, BIT_5, 8);
void res_4_l() res_b_r(L, BIT_4, 8);
void res_3_l() res_b_r(L, BIT_3, 8);
void res_2_l() res_b_r(L, BIT_2, 8);
void res_1_l() res_b_r(L, BIT_1, 8);
void res_0_l() res_b_r(L, BIT_0, 8);
void res_7_iX() res_b_r(LX, BIT_7, 15);
void res_6_iX() res_b_r(LX, BIT_6, 15);
void res_5_iX() res_b_r(LX, BIT_5, 15);
void res_4_iX() res_b_r(LX, BIT_4, 15);
void res_3_iX() res_b_r(LX, BIT_3, 15);
void res_2_iX() res_b_r(LX, BIT_2, 15);
void res_1_iX() res_b_r(LX, BIT_1, 15);
void res_0_iX() res_b_r(LX, BIT_0, 15);
void res_7_iY() res_b_r(LY, BIT_7, 15);
void res_6_iY() res_b_r(LY, BIT_6, 15);
void res_5_iY() res_b_r(LY, BIT_5, 15);
void res_4_iY() res_b_r(LY, BIT_4, 15);
void res_3_iY() res_b_r(LY, BIT_3, 15);
void res_2_iY() res_b_r(LY, BIT_2, 15);
void res_1_iY() res_b_r(LY, BIT_1, 15);
void res_0_iY() res_b_r(LY, BIT_0, 15);
void res_7_a() res_b_r(A, BIT_7, 8);
void res_6_a() res_b_r(A, BIT_6, 8);
void res_5_a() res_b_r(A, BIT_5, 8);
void res_4_a() res_b_r(A, BIT_4, 8);
void res_3_a() res_b_r(A, BIT_3, 8);
void res_2_a() res_b_r(A, BIT_2, 8);
void res_1_a() res_b_r(A, BIT_1, 8);
void res_0_a() res_b_r(A, BIT_0, 8);

#undef res_b_r

/*=========================================================================*
 *                            res_b_phl                                    *
 *=========================================================================*/

#define res_b_phl(BIT,expr,TS) { \
	LOCAL USHORT tmp; \
	\
	T(TS); \
	tmp = expr; \
	writebyte(tmp, readbyte(tmp) & ~(UCHAR)BIT ); \
}

void res_7_phl() res_b_phl(BIT_7,HL,15);
void res_6_phl() res_b_phl(BIT_6,HL,15);
void res_5_phl() res_b_phl(BIT_5,HL,15);
void res_4_phl() res_b_phl(BIT_4,HL,15);
void res_3_phl() res_b_phl(BIT_3,HL,15);
void res_2_phl() res_b_phl(BIT_2,HL,15);
void res_1_phl() res_b_phl(BIT_1,HL,15);
void res_0_phl() res_b_phl(BIT_0,HL,15);
void res_7_pix() res_b_phl(BIT_7, pCBIX, 23);
void res_6_pix() res_b_phl(BIT_6, pCBIX, 23);
void res_5_pix() res_b_phl(BIT_5, pCBIX, 23);
void res_4_pix() res_b_phl(BIT_4, pCBIX, 23);
void res_3_pix() res_b_phl(BIT_3, pCBIX, 23);
void res_2_pix() res_b_phl(BIT_2, pCBIX, 23);
void res_1_pix() res_b_phl(BIT_1, pCBIX, 23);
void res_0_pix() res_b_phl(BIT_0, pCBIX, 23);
void res_7_piy() res_b_phl(BIT_7, pCBIY, 23);
void res_6_piy() res_b_phl(BIT_6, pCBIY, 23);
void res_5_piy() res_b_phl(BIT_5, pCBIY, 23);
void res_4_piy() res_b_phl(BIT_4, pCBIY, 23);
void res_3_piy() res_b_phl(BIT_3, pCBIY, 23);
void res_2_piy() res_b_phl(BIT_2, pCBIY, 23);
void res_1_piy() res_b_phl(BIT_1, pCBIY, 23);
void res_0_piy() res_b_phl(BIT_0, pCBIY, 23);

#undef res_b_phl

/* EOF: Bits.c */
